Index: trunk/MagicSoft/Mars/mjobs/MJCalibration.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 3155)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 3199)
@@ -204,24 +204,23 @@
 
     // Create histograms to display
-    MHCamera disp1  (geomcam, "Cal;Charge",         "Fitted Mean Charges");
-    MHCamera disp2  (geomcam, "Cal;SigmaCharge",    "Sigma of Fitted Charges");
-    MHCamera disp3  (geomcam, "Cal;FitProb",        "Probability of Fit");
-    MHCamera disp4  (geomcam, "Cal;RSigma",         "Reduced Sigmas");
-    MHCamera disp5  (geomcam, "Cal;RSigma/Charge",  "Reduced Sigma per Charge");
-    MHCamera disp6  (geomcam, "Cal;FFactorPhe",     "Nr. of Phe's (F-Factor Method)");
-    MHCamera disp7  (geomcam, "Cal;FFactorConv",    "Conversion Factor (F-Factor Method)");
-    MHCamera disp8  (geomcam, "Cal;FFactorFFactor", "Total F-Factor (F-Factor Method)");
-    MHCamera disp9  (geomcam, "Cal;BlindPixPh",     "Photon flux inside plexiglass (Blind Pixel Method)");
-    MHCamera disp10 (geomcam, "Cal;BlindPixConv",   "Conversion Factor (Blind Pixel Method)");
-    MHCamera disp11 (geomcam, "Cal;BlindPixFFactor","Total F-Factor (Blind Pixel Method)");
-    MHCamera disp12 (geomcam, "Cal;PINDiodePh",     "Photons flux outside plexiglass (PIN Diode Method)");
-    MHCamera disp13 (geomcam, "Cal;PINDiodeConv",   "Conversion Factor (PIN Diode Method)");
-    MHCamera disp14 (geomcam, "Cal;PINDiodeFFactor","Total F-Factor (PIN Diode Method)");
-    MHCamera disp15 (geomcam, "Cal;Excluded",       "Pixels previously excluded");
-    MHCamera disp16 (geomcam, "Cal;NotFitted",      "Pixels that could not be fitted");
-    MHCamera disp17 (geomcam, "Cal;NotFitValid",    "Pixels with not valid fit results");
-    MHCamera disp18 (geomcam, "Cal;Oscillation",    "Oscillating Pixels");
-    MHCamera disp19 (geomcam, "Cal;Saturation",     "Pixels with saturated Hi Gain");
-
+    MHCamera disp1 (geomcam, "Cal;Charge",         "Fitted Mean Charges");
+    MHCamera disp2 (geomcam, "Cal;SigmaCharge",    "Sigma of Fitted Charges");
+    MHCamera disp3 (geomcam, "Cal;FitProb",        "Probability of Fit");
+    MHCamera disp4 (geomcam, "Cal;RSigma",         "Reduced Sigmas");
+    MHCamera disp5 (geomcam, "Cal;RSigma/Charge",  "Reduced Sigma per Charge");
+    MHCamera disp6 (geomcam, "Cal;FFactorPhe",     "Nr. of Phe's (F-Factor Method)");
+    MHCamera disp7 (geomcam, "Cal;FFactorConv",    "Conversion Factor (F-Factor Method)");
+    MHCamera disp8 (geomcam, "Cal;FFactorFFactor", "Total F-Factor (F-Factor Method)");
+    MHCamera disp9 (geomcam, "Cal;BlindPixPh",     "Photon flux inside plexiglass (Blind Pixel Method)");
+    MHCamera disp10(geomcam, "Cal;BlindPixConv",   "Conversion Factor (Blind Pixel Method)");
+    MHCamera disp11(geomcam, "Cal;BlindPixFFactor","Total F-Factor (Blind Pixel Method)");
+    MHCamera disp12(geomcam, "Cal;PINDiodePh",     "Photons flux outside plexiglass (PIN Diode Method)");
+    MHCamera disp13(geomcam, "Cal;PINDiodeConv",   "Conversion Factor (PIN Diode Method)");
+    MHCamera disp14(geomcam, "Cal;PINDiodeFFactor","Total F-Factor (PIN Diode Method)");
+    MHCamera disp15(geomcam, "Cal;Excluded",       "Pixels previously excluded");
+    MHCamera disp16(geomcam, "Cal;NotFitted",      "Pixels that could not be fitted");
+    MHCamera disp17(geomcam, "Cal;NotFitValid",    "Pixels with not valid fit results");
+    MHCamera disp18(geomcam, "Cal;Oscillation",    "Oscillating Pixels");
+    MHCamera disp19(geomcam, "Cal;Saturation",     "Pixels with saturated Hi Gain");
 
     // Fitted charge means and sigmas
@@ -272,23 +271,22 @@
     disp19.SetCamContent(fCalibrationCam,31);
 
-
-    disp1.SetYTitle("Charge [FADC units]");
-    disp2.SetYTitle("\\sigma_{Charge} [FADC units]");
-    disp3.SetYTitle("P_{Charge} [1]");
-
-    disp4.SetYTitle("\\sqrt{\\sigma^{2}_{Charge} - RMS^{2}_{Ped}} [FADC Counts]");
-    disp5.SetYTitle("Reduced Sigma / Mean Charge [1]");
-
-    disp6.SetYTitle("Nr. Photo-Electrons [1]");
-    disp7.SetYTitle("Conversion Factor [PhE/FADC Count]");
-    disp8.SetYTitle("\\sqrt{N_{PhE}}*\\sigma_{Charge}/\\mu_{Charge} [1]");
-
-    disp9.SetYTitle("Photon flux [ph/mm^2]");
-    disp10.SetYTitle("Conversion Factor [Phot/FADC Count]");
-    disp11.SetYTitle("\\sqrt{N_{Ph}}*\\sigma_{Charge}/\\mu_{Charge} [1]");
-
-    disp12.SetYTitle("Photon flux [ph/mm^2]");
-    disp13.SetYTitle("Conversion Factor [Phot/FADC Count]");
-    disp14.SetYTitle("\\sqrt{N_{Ph}}*\\sigma_{Charge}/\\mu_{Charge} [1]");
+    disp1.SetYTitle("Q [FADC units]");
+    disp2.SetYTitle("\\sigma_{Q} [FADC units]");
+    disp3.SetYTitle("P_{Q} [1]");
+
+    disp4.SetYTitle("\\sqrt{\\sigma^{2}_{Q} - RMS^{2}_{Ped}} [FADC Counts]");
+    disp5.SetYTitle("Red.Sigma/<Q> [1]");
+
+    disp6.SetYTitle("PhE [#]");
+    disp7.SetYTitle("Conv.Factor [PhE/FADC units]");
+    disp8.SetYTitle("\\sqrt{N_{PhE}}*\\sigma_{Q}/\\mu_{Q} [1]");
+
+    disp9.SetYTitle("Phot.flux [ph/mm^{2}]");
+    disp10.SetYTitle("Conv.Factor [Phot/FADC Count]");
+    disp11.SetYTitle("\\sqrt{N_{Ph}}*\\sigma_{Q}/\\mu_{Q} [1]");
+
+    disp12.SetYTitle("Phot.flux [ph/mm^{2}]");
+    disp13.SetYTitle("Conv.Factor [Phot/FADC Count]");
+    disp14.SetYTitle("\\sqrt{N_{Ph}}*\\sigma_{Q}/\\mu_{Q} [1]");
 
     disp15.SetYTitle("[1]");
@@ -357,6 +355,5 @@
     c8.Divide(1,3);
 
-    CamDraw(c8, 1, 4, disp19, 0);
-
+    CamDraw(c8, 1, 1, disp19, 0);
 }
 
@@ -495,6 +492,6 @@
     // when the calibration hardware-trigger is working)
     // 
-    MFCosmics            cosmics;
-    MContinue            cont(&cosmics);
+    MFCosmics cosmics;
+    MContinue cont(&cosmics);
 
     //
Index: trunk/MagicSoft/Mars/mjobs/MJExtractSignal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJExtractSignal.cc	(revision 3155)
+++ trunk/MagicSoft/Mars/mjobs/MJExtractSignal.cc	(revision 3199)
@@ -298,15 +298,23 @@
     *fLog << endl;
 
+    // Setup Lists
+    MParList plist;
+    plist.AddToList(&pedcam);
+
+    MTaskList tlist;
+    plist.AddToList(&tlist);
+
+    // Setup Parameters
+
+    // Make sure, that at least an empty MBadPixelsCam is available
+    // This is necessary for input which don't contain a MBadPixelsCam
+    MBadPixelsCam badcam;
+    plist.AddToList(&badcam);
+
+    // Setup Task-lists
     MReadMarsFile read("Events");
     read.DisableAutoScheme();
     static_cast<MRead&>(read).AddFiles(*fRuns);
 
-    // Setup Tasklist
-    MParList plist;
-    plist.AddToList(&pedcam);
-
-    MTaskList tlist;
-    plist.AddToList(&tlist);
-
     MGeomApply      apply; // Only necessary to craete geometry
     MBadPixelsMerge merge(&fBadPixels);
@@ -320,6 +328,6 @@
     write.AddContainer("MExtractedSignalCam", "Events");
     write.AddContainer("MTime",               "Events");
+    // FIXME: CRAHSES! write.AddContainer("MPedestalCam",        "RunHeaders");
     write.AddContainer("MRawRunHeader",       "RunHeaders");
-    write.AddContainer("MPedestalCam",        "RunHeaders");
     write.AddContainer("MBadPixelsCam",       "RunHeaders");
 