Index: trunk/MagicSoft/Mars/macros/CCDataCheck.C
===================================================================
--- trunk/MagicSoft/Mars/macros/CCDataCheck.C	(revision 3218)
+++ trunk/MagicSoft/Mars/macros/CCDataCheck.C	(revision 3221)
@@ -26,6 +26,7 @@
 // It displays 9 tabs:
 //   - Drive system
+//   - Camera status
 //   - HV of power supplies and HV settings
-//   - DC of power supplies and several camera related status plots
+//   - DC of power supplies 
 //   - LV power supplies
 //   - Cooling system
@@ -239,5 +240,5 @@
   plist.AddToList(&bins5);
   MBinning bins6("BinningTrigZdY");
-  bins6.SetEdges(100, 0, 1500);
+  bins6.SetEdges(10000, 0, 15000);
   plist.AddToList(&bins6);
 
@@ -578,4 +579,5 @@
       TAxis *axey = hist->GetYaxis();
       TAxis *axex = hist->GetXaxis();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("");
@@ -617,4 +619,5 @@
   if (hvt->GetGraph()->GetN())
     {
+      hvt->GetGraph()->GetHistogram()->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hvt->GetGraph()->GetHistogram()->SetXTitle("Time");
       hvt->GetGraph()->GetHistogram()->SetYTitle("Zd [\\circ]");
@@ -627,91 +630,11 @@
   // Camera report 
   // 
-  // ************************* HV of power supplies ***************************
+  // **************************** CAMERA STATUS ********************
   if ((d = evtloop.GetDisplay()))
-    TCanvas &c2 = d.AddTab("CAMERA HV");
+    TCanvas &c2 = d.AddTab("CAMERA STATUS");
   else
     TCanvas *c2 = new TCanvas();
-  c2->Divide(2,2);
+  c2->Divide(1,2);
   c2->cd(1);
-  // ---------------------------- Power supplies ------------------------------
-  TLegend *legHV = new TLegend(0.85,0.75,0.99,0.99);
-  g = hHVA.GetGraph();
-  g->SetMarkerColor(2);
-  g->SetLineColor(2);
-  g->SetTitle("Voltages of power supplies");
-  legHV->AddEntry(g,"PS A (hvps1)","l");
-  clone1 = (MHVsTime*)hHVA.DrawClone("nonew");
-  if(clone1->GetGraph()->GetN())
-    {
-      hist = clone1->GetGraph()->GetHistogram();
-      hist->SetXTitle("Time");
-      hist->SetYTitle("High voltage [V]");
-      hist->SetMinimum(0);
-    }
-  g = hHVB.GetGraph();
-  g->SetMarkerColor(3);
-  g->SetLineColor(3);
-  legHV->AddEntry(g,"PS B (hvps2)","l");
-  clone1 = (MHVsTime*)hHVB.DrawClone("nonewsame");
-  legHV->DrawClone();
-  // ---------------------------- HV settings ---------------------------------
-  c2->cd(2);
-  g = hCamMean.GetGraph();
-  g->SetMarkerColor(2);
-  g->SetLineColor(2);
-  g->SetTitle("Camera mean HV settings");
-  clone1 = (MHVsTime*)hCamMean.DrawClone("nonew");
-  if(clone1->GetGraph()->GetN())
-    {
-      hist = clone1->GetGraph()->GetHistogram();
-      hist->SetXTitle("Time");
-      hist->SetYTitle("HV [V]");
-      hist->SetMinimum(0);
-    }
-  c2->cd(3);
-  Sum = (MHCamera*)HVdisplay.GetHistByName("sum");
-  TVirtualPad *c = gPad;
-  c->cd(1);
-  gPad->SetBorderMode(0);
-  Sum->SetYTitle("Mean");
-  Sum->DrawClone("pixelindex"); 
-  c2->cd(4);
-  gPad->SetBorderMode(0);
-  Sum->SetYTitle("Mean HV settings");
-  Sum->DrawClone("EPhist");
-
-  // ******************** Currents of power supplies *******************
-  if ((d = evtloop.GetDisplay()))
-    TCanvas &c3 = d.AddTab("CAMERA DC");
-  else
-    TCanvas *c3 = new TCanvas();
- // ----------------------------- Power supplies ------------------------------
-  c3->Divide(1,2);
-  c3->cd(1);
-  TLegend *legC = new TLegend(0.85,0.75,0.99,0.99);
-  g = hCA.GetGraph();
-  g->SetMarkerColor(2);
-  g->SetLineColor(2);
-  g->SetTitle("Currents of power supplies");
-  legC->AddEntry(g,"Power supply A (curr1)","l");
-  clone1 = (MHVsTime*)hCA.DrawClone("nonew");
-  if(clone1->GetGraph()->GetN())
-    {
-      hist = clone1->GetGraph()->GetHistogram();
-      hist->SetXTitle("Time");
-      hist->SetYTitle("Current [mA]");
-      hist->SetMinimum(0);
-    }
-  g = hCB.GetGraph();
-  g->SetMarkerColor(3);
-  g->SetLineColor(3);
-  legC->AddEntry(g,"Power supply B (curr2)","l");
-  clone1 = (MHVsTime*)hCB.DrawClone("nonewsame");
-  legC->DrawClone();
-  c3->cd(2);
-  gPad->SetBorderMode(0);
-  gPad->Divide(2,2);
-  TVirtualPad *c = gPad;
-  c->cd(1);
   g = hCamStatus.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
@@ -735,13 +658,14 @@
       axey->SetBinLabel(axey->FindFixBin(8),"SHUTD");
       axey->SetBinLabel(axey->FindFixBin(9),"N/A");
-      axey->SetLabelSize(0.07);
+      axey->SetLabelSize(0.05);
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("");
     }
-  c->cd(2);
-  g = hCamStatusDC.GetGraph();
-  g->SetMarkerStyle(kFullDotSmall);
-  g->SetTitle("Camera DC status");
-  clone1 = (MHVsTime*)hCamStatusDC.DrawClone("nonew");
+  c2->cd(2);
+  g = hLidsStatus.GetGraph();
+  g->SetMarkerStyle(kFullDotSmall);
+  g->SetTitle("Camera Lids status");
+  clone1 = (MHVsTime*)hLidsStatus.DrawClone("nonew");
   if(clone1->GetGraph()->GetN())
     {
@@ -752,14 +676,51 @@
       axey->Set(10,-0.5,9.5);
       axey->SetBinLabel(axey->FindFixBin(0),"Error");
-      axey->SetBinLabel(axey->FindFixBin(1),"Alarm");
-      axey->SetBinLabel(axey->FindFixBin(3),"Hot");
-      axey->SetBinLabel(axey->FindFixBin(5),"Ok");
-      axey->SetBinLabel(axey->FindFixBin(6),"Warm");
+      axey->SetBinLabel(axey->FindFixBin(1),"SafetyLimit");
+      axey->SetBinLabel(axey->FindFixBin(4),"Closed");
+      axey->SetBinLabel(axey->FindFixBin(5),"Opened");
+      axey->SetBinLabel(axey->FindFixBin(6),"Moving");
+      axey->SetBinLabel(axey->FindFixBin(7),"Stopped");
       axey->SetBinLabel(axey->FindFixBin(9),"n/a");
-      axey->SetLabelSize(0.07);
+      axey->SetLabelSize(0.05);
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("");
     }
-  c->cd(3);
+  // ************************* HV of power supplies ***************************
+  if ((d = evtloop.GetDisplay()))
+    TCanvas &c3 = d.AddTab("CAMERA HV");
+  else
+    TCanvas *c3 = new TCanvas();
+  c3->Divide(2,2);
+  c3->cd(1);
+  // --------------- Power supplies  and HV settings --------------------------
+  TLegend *legHV = new TLegend(0.75,0.85,0.99,0.99);
+  g = hHVA.GetGraph();
+  g->SetMarkerColor(2);
+  g->SetLineColor(2);
+  g->SetTitle("Voltages of power supplies and camera settings");
+  legHV->AddEntry(g,"PS A (hvps1)","l");
+  clone1 = (MHVsTime*)hHVA.DrawClone("nonew");
+  if(clone1->GetGraph()->GetN())
+    {
+      hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
+      hist->SetXTitle("Time");
+      hist->SetYTitle("High voltage [V]");
+      hist->SetMinimum(0);
+    }
+  g = hHVB.GetGraph();
+  g->SetMarkerColor(3);
+  g->SetLineColor(3);
+  legHV->AddEntry(g,"PS B (hvps2)","l");
+  clone1 = (MHVsTime*)hHVB.DrawClone("nonewsame");
+  g = hCamMean.GetGraph();
+  g->SetMarkerColor(4);
+  g->SetLineColor(4);
+  legHV->AddEntry(g,"Camera mean HV","l");
+  clone1 = (MHVsTime*)hCamMean.DrawClone("nonewsame");
+  legHV->DrawClone();
+  // ---------------------------- HV status -----------------------------------
+  c3->cd(2);
   g = hHVStatus.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
@@ -781,13 +742,56 @@
       axey->SetBinLabel(axey->FindFixBin(6),"LimCurrentWarning");
       axey->SetBinLabel(axey->FindFixBin(9),"n/a");
-      axey->SetLabelSize(0.07);
+      axey->SetLabelSize(0.05);
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("");
     }
-  c->cd(4);
-  g = hLidsStatus.GetGraph();
-  g->SetMarkerStyle(kFullDotSmall);
-  g->SetTitle("Camera Lids status");
-  clone1 = (MHVsTime*)hLidsStatus.DrawClone("nonew");
+  // ---------------------------- HV settings ---------------------------------
+  c3->cd(3);
+  Sum = (MHCamera*)HVdisplay.GetHistByName("sum");
+  TVirtualPad *c = gPad;
+  c->cd(1);
+  gPad->SetBorderMode(0);
+  Sum->SetYTitle("Mean");
+  Sum->DrawClone("pixelindex"); 
+  c3->cd(4);
+  gPad->SetBorderMode(0);
+  Sum->SetYTitle("Mean HV settings");
+  Sum->DrawClone("EPhist");
+
+  // ******************** Currents of power supplies *******************
+  if ((d = evtloop.GetDisplay()))
+    TCanvas &c4 = d.AddTab("CAMERA DC");
+  else
+    TCanvas *c4 = new TCanvas();
+ // ----------------------------- Power supplies ------------------------------
+  c4->Divide(1,2);
+  c4->cd(1);
+  TLegend *legC = new TLegend(0.85,0.75,0.99,0.99);
+  g = hCA.GetGraph();
+  g->SetMarkerColor(2);
+  g->SetLineColor(2);
+  g->SetTitle("Currents of power supplies");
+  legC->AddEntry(g,"PS A (curr1)","l");
+  clone1 = (MHVsTime*)hCA.DrawClone("nonew");
+  if(clone1->GetGraph()->GetN())
+    {
+      hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
+      hist->SetXTitle("Time");
+      hist->SetYTitle("Current [mA]");
+      hist->SetMinimum(0);
+    }
+  g = hCB.GetGraph();
+  g->SetMarkerColor(3);
+  g->SetLineColor(3);
+  legC->AddEntry(g,"PS B (curr2)","l");
+  clone1 = (MHVsTime*)hCB.DrawClone("nonewsame");
+  legC->DrawClone();
+  c4->cd(2);
+  g = hCamStatusDC.GetGraph();
+  g->SetMarkerStyle(kFullDotSmall);
+  g->SetTitle("Camera DC status");
+  clone1 = (MHVsTime*)hCamStatusDC.DrawClone("nonew");
   if(clone1->GetGraph()->GetN())
     {
@@ -798,21 +802,23 @@
       axey->Set(10,-0.5,9.5);
       axey->SetBinLabel(axey->FindFixBin(0),"Error");
-      axey->SetBinLabel(axey->FindFixBin(1),"SafetyLimit");
-      axey->SetBinLabel(axey->FindFixBin(4),"Closed");
-      axey->SetBinLabel(axey->FindFixBin(5),"Opened");
-      axey->SetBinLabel(axey->FindFixBin(6),"Moving");
-      axey->SetBinLabel(axey->FindFixBin(7),"Stopped");
+      axey->SetBinLabel(axey->FindFixBin(1),"Alarm");
+      axey->SetBinLabel(axey->FindFixBin(3),"Hot");
+      axey->SetBinLabel(axey->FindFixBin(5),"Ok");
+      axey->SetBinLabel(axey->FindFixBin(6),"Warm");
       axey->SetBinLabel(axey->FindFixBin(9),"n/a");
-      axey->SetLabelSize(0.07);
+      axey->SetLabelSize(0.09);
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("");
     }
+
+
   // ***************************** LV power supplies **************************
   if ((d = evtloop.GetDisplay()))
-    TCanvas &c4 = d.AddTab("CAMERA LV");
+    TCanvas &c5 = d.AddTab("CAMERA LV");
   else
-    TCanvas *c4 = new TCanvas();
-  c4->Divide(2,2);
-  c4->cd(1);
+    TCanvas *c5 = new TCanvas();
+  c5->Divide(2,2);
+  c5->cd(1);
   g = hLVTemp.GetGraph();
   g->SetMarkerColor(2);
@@ -823,8 +829,9 @@
     {
       hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Temperature [\\circ]");
     }
-  c4->cd(2);
+  c5->cd(2);
   g = hLVHum.GetGraph();
   g->SetMarkerColor(4);
@@ -835,8 +842,9 @@
     {
       hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Humidity [%]");
     }
-  c4->cd(3);
+  c5->cd(3);
   g = hLVStatus.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
@@ -856,8 +864,9 @@
       axey->SetBinLabel(axey->FindFixBin(5),"On");
       axey->SetBinLabel(axey->FindFixBin(9),"n/a");
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("");
     }
-  c4->cd(4);
+  c5->cd(4);
   g = hLVRPS.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
@@ -867,4 +876,5 @@
     {
       hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("");
@@ -878,22 +888,23 @@
   // ****************************** Cooling ***********************************
   if ((d = evtloop.GetDisplay()))
-    TCanvas &c5 = d.AddTab("COOLING SYSTEM");
+    TCanvas &c6 = d.AddTab("COOLING SYSTEM");
   else
-    TCanvas *c5 = new TCanvas();
+    TCanvas *c6 = new TCanvas();
   gStyle->SetPadGridX(kTRUE);
   gStyle->SetPadGridY(kTRUE);
-  c5->Divide(2,2);
-  c5->cd(1);
+  c6->Divide(2,2);
+  c6->cd(1);
   // -------------------------- Camera temperatures ---------------------------
-  TLegend *legtemp = new TLegend(0.85,0.75,0.99,0.99);
+  TLegend *legtemp = new TLegend(0.75,0.80,0.99,0.99);
   g = hTCenter.GetGraph();
   g->SetMarkerColor(8);
   g->SetLineColor(8);
   g->SetTitle("Camera temperature");
-  legtemp->AddEntry(g,"T at camera center","l");
+  legtemp->AddEntry(g,"camera center","l");
   clone1 = (MHVsTime*)hTCenter.DrawClone("nonew");
   if(clone1->GetGraph()->GetN())
     {
       hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Temperature [\\circ C]");
@@ -903,18 +914,18 @@
   g->SetMarkerColor(12);
   g->SetLineColor(12);
-  legtemp->AddEntry(g,"T at camera wall","l");
+  legtemp->AddEntry(g,"camera wall","l");
   clone1 = (MHVsTime*)hTWall.DrawClone("nonewsame");
   g = hTWater.GetGraph();
   g->SetMarkerColor(4);
   g->SetLineColor(4);
-  legtemp->AddEntry(g,"T at water deposit","l");
+  legtemp->AddEntry(g,"water deposit","l");
   clone1 = (MHVsTime*)hTWater.DrawClone("nonewsame");
   g = hTOptLink.GetGraph();
   g->SetMarkerColor(2);
   g->SetLineColor(2);
-  legtemp->AddEntry(g,"T at optical links","l");
+  legtemp->AddEntry(g,"optical links","l");
   clone1 = (MHVsTime*)hTOptLink.DrawClone("nonewsame");
   legtemp->DrawClone();
-  c5->cd(2);
+  c6->cd(2);
   g = hCoolStatus.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
@@ -936,19 +947,21 @@
       axey->SetBinLabel(axey->FindFixBin(9),"n/a");
       axey->SetLabelSize(0.05);
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("");
     }
   // ------------------------- Camera relative humidity -----------------------
-  c5->cd(3);
-  TLegend *leghum = new TLegend(0.75,0.75,0.99,0.99);
+  c6->cd(3);
+  TLegend *leghum = new TLegend(0.75,0.85,0.99,0.99);
   g = hHCenter.GetGraph();
   g->SetMarkerColor(8);
   g->SetLineColor(8);
   g->SetTitle("Camera relative humidity");
-  leghum->AddEntry(g,"RH at camera center","l");
+  leghum->AddEntry(g,"camera center","l");
   clone1 = (MHVsTime*)hHCenter.DrawClone("nonew");
   if(clone1->GetGraph()->GetN())
     {
       hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Relative humidity [%]");
@@ -959,9 +972,9 @@
   g->SetMarkerColor(12);
   g->SetLineColor(12);
-  leghum->AddEntry(g,"RH at camera wall","l");
+  leghum->AddEntry(g,"camera wall","l");
   clone1 = (MHVsTime*)hHWall.DrawClone("nonewsame");
   leghum->DrawClone();
   // ---------------------- Temperature distribution --------------------------
-  c5->cd(4);
+  c6->cd(4);
   hist = hTempOptLink.GetHistByName("TOptLink");
   hist->SetXTitle("Temperature [\\circ C]");
@@ -975,11 +988,12 @@
   //
   if ((d = evtloop.GetDisplay()))
-    TCanvas &c6 = d.AddTab("TRIGGER SYSTEM");
+    TCanvas &c7 = d.AddTab("TRIGGER SYSTEM");
   else
-    TCanvas *c6 = new TCanvas();
-  c6->Divide(1,3);
-  c6->cd(1);
+    TCanvas *c7 = new TCanvas();
+  c7->Divide(1,3);
+  c7->cd(1);
   gStyle->SetPadGridX(kTRUE);
   gStyle->SetPadGridY(kTRUE);
+  gPad->SetLogy();
   TLegend *legtrig = new TLegend(0.85,0.85,0.99,0.99);
   g = hTrigBL2.GetGraph();
@@ -993,4 +1007,8 @@
     {
       hist = clone1->GetGraph()->GetHistogram();
+      hist->SetMinimum(1);
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
+      hist->GetXaxis()->SetLabelSize(0.05);
+      hist->GetYaxis()->SetLabelSize(0.05);
       hist->SetXTitle("Time");
       hist->SetYTitle("L2 trigger rate [Hz]"); 
@@ -1002,6 +1020,9 @@
   clone1 = (MHVsTime*)hTrigAL2.DrawClone("nonewsame");
   legtrig->DrawClone();
-   c6->cd(2);
+   c7->cd(2);
+   gPad->SetLogy();
    hist = hTrigZd.GetHistByName("TrigZd");
+   hist->GetXaxis()->SetLabelSize(0.05);
+   hist->GetYaxis()->SetLabelSize(0.05);
    hist->SetXTitle("Zenith angle[\\circ]");
    hist->SetYTitle("Trigger rate [Hz]");
@@ -1010,5 +1031,6 @@
    hist->SetStats(0);
    mh3 = (MH3*)hTrigZd.DrawClone("nonew");
-   c6->cd(3);
+   hist->SetMinimum(1);
+   c7->cd(3);
    g = hTrigStatus.GetGraph();
    g->SetMarkerStyle(kFullDotSmall);
@@ -1028,5 +1050,7 @@
        axey->SetBinLabel(axey->FindFixBin(4),"Active");
        axey->SetBinLabel(axey->FindFixBin(5),"Stopped");
-       axey->SetLabelSize(0.07);
+       axey->SetLabelSize(0.05);
+       hist->GetXaxis()->SetLabelSize(0.05);
+       hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
        hist->SetXTitle("Time");
        hist->SetYTitle("");
@@ -1034,10 +1058,11 @@
   // ***************************** Trigger of macrocells **********************
   if ((d = evtloop.GetDisplay()))
-    TCanvas &c7 = d.AddTab("TRIG. MACROCELLs");
+    TCanvas &c8 = d.AddTab("TRIG. MACROCELLs");
   else
-    TCanvas *c7 = new TCanvas();
-  c7->Divide(2,2);
-  c7->cd(1);
-  TLegend *legtrig = new TLegend(0.80,0.70,0.99,0.99);
+    TCanvas *c8 = new TCanvas();
+  c8->Divide(2,2);
+  c8->cd(1);
+  gPad->SetLogy();
+  TLegend *legtrig = new TLegend(0.70,0.80,0.99,0.99);
   g = htrigmc1.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
@@ -1051,10 +1076,13 @@
       if(hist->GetMaximum()<g->GetHistogram()->GetMaximum())
 	hist->SetMaximum(g->GetHistogram()->GetMaximum());
+      hist->SetMinimum(1);
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Trigger [Hz]");
     }
   legtrig->DrawClone();
-  c7->cd(2);
-  TLegend *legtrig = new TLegend(0.80,0.70,0.99,0.99);
+  c8->cd(2);
+  gPad->SetLogy();
+  TLegend *legtrig = new TLegend(0.70,0.70,0.99,0.99);
   g = htrigmc2.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
@@ -1068,4 +1096,6 @@
       if(hist->GetMaximum()<g->GetHistogram()->GetMaximum())
 	hist->SetMaximum(g->GetHistogram()->GetMaximum());
+      hist->SetMinimum(1);
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Trigger [Hz]");
@@ -1107,6 +1137,7 @@
   pixclone1 = (MHPixVsTime*)htrigmc7.DrawClone("nonewsame");
   legtrig->DrawClone();
-  c7->cd(3);
-  TLegend *legtrig = new TLegend(0.80,0.70,0.99,0.99);
+  c8->cd(3);
+  gPad->SetLogy();
+  TLegend *legtrig = new TLegend(0.70,0.70,0.99,0.99);
   g = htrigmc8.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
@@ -1120,4 +1151,8 @@
     {
       hist = pixclone1->GetGraph()->GetHistogram();
+      if(hist->GetMaximum()<g->GetHistogram()->GetMaximum())
+	hist->SetMaximum(g->GetHistogram()->GetMaximum());
+      hist->SetMinimum(1);
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Trigger [Hz]");
@@ -1157,6 +1192,7 @@
   pixclone1 = (MHPixVsTime*)htrigmc13.DrawClone("nonewsame");
   legtrig->DrawClone();
-  c7->cd(4);
-  TLegend *legtrig = new TLegend(0.80,0.70,0.99,0.99);
+  c8->cd(4);
+  gPad->SetLogy();
+  TLegend *legtrig = new TLegend(0.70,0.70,0.99,0.99);
   TGraph *g = htrigmc14.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
@@ -1170,4 +1206,6 @@
       if(hist->GetMaximum()<g->GetHistogram()->GetMaximum())
 	hist->SetMaximum(g->GetHistogram()->GetMaximum());
+      hist->SetMinimum(1);
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Trigger [Hz]");
@@ -1214,61 +1252,65 @@
   //
   if ((d = evtloop.GetDisplay()))
-    TCanvas &c8 = d.AddTab("WEATHER STATION");
+    TCanvas &c9 = d.AddTab("WEATHER STATION");
   else
-    TCanvas *c8 = new TCanvas();
-  c8->Divide(2,2);
+    TCanvas *c9 = new TCanvas();
+  c9->Divide(2,2);
   // ----------------------- Relative humidity --------------------------------
-  c8->cd(1);
+  c9->cd(1);
   g = hCCHum.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
   g->SetMarkerColor(4);
   g->SetLineColor(4);
-  g->SetTitle("Relative humidity");
+  g->SetTitle("Relative humidity outside");
   clone1 = (MHVsTime*)hCCHum.DrawClone("nonew");
   if(clone1->GetGraph()->GetN())
     {
       hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Humidity [%]"); 
     }
   // -------------------------- Temperature -----------------------------------
-  c8->cd(2);
+  c9->cd(2);
   g = hCCTemp.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
   g->SetMarkerColor(2);
   g->SetLineColor(2);
-  g->SetTitle("Temperature");
+  g->SetTitle("Temperature outside");
   clone1 = (MHVsTime*)hCCTemp.DrawClone("nonew");
   if(clone1->GetGraph()->GetN())
     {
       hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Temperature [\\circ C]"); 
     }
   // --------------------------- Wind speed -----------------------------------
-  c8->cd(3);
+  c9->cd(3);
   g = hCCWS.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
   g->SetMarkerColor(3);
   g->SetLineColor(3);
-  g->SetTitle("Wind speed");
+  g->SetTitle("Wind speed outside");
   clone1 = (MHVsTime*)hCCWS.DrawClone("nonew");
   if(clone1->GetGraph()->GetN())
     {
       hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Wind speed [km/h]"); 
     }
   // -------------------------- Solar radiation -------------------------------
-  c8->cd(4);
+  c9->cd(4);
   g = hCCSR.GetGraph();
   g->SetMarkerStyle(kFullDotSmall);
   g->SetMarkerColor(9);
   g->SetLineColor(9);
-  g->SetTitle("Solar radiation");
+  g->SetTitle("Solar radiation outside");
   clone1 = (MHVsTime*)hCCSR.DrawClone("nonew");
   if(clone1->GetGraph()->GetN())
     {
       hist = clone1->GetGraph()->GetHistogram();
+      hist->GetXaxis()->SetTimeFormat("%H:%M %F1995-01-01 00:00:00");
       hist->SetXTitle("Time");
       hist->SetYTitle("Solar radiation [W/m^2]"); 
@@ -1293,5 +1335,6 @@
       c6->Print(directory+file+".ps");
       c7->Print(directory+file+".ps");
-      c8->Print(directory+file+".ps)");
+      c8->Print(directory+file+".ps");
+      c9->Print(directory+file+".ps)");
     }
 }